<template>
  <div id="app">
    <div class="header">
      <div class="block">
        <div>
          <h1><img src="https://i.imgur.com/E9fz9pu.png" alt="icon" class="icon" /> User Details</h1>
        </div>
        <div>
          <span v-if="intransit > 0" class="intransit-number">
          In transit : {{ intransit }}</span>
          <span v-if="late > 0" class="late-number">
          Late : {{ late }}</span> 
        </div>
      </div>
      
    </div>
    <div class="table-container">
      <table v-if="users">
        <thead>
          <tr>
            <th>Name</th>
            <th>Department</th>
            <th>From</th>
            <th>To</th>
            <th>Date</th>
            <th>Scheduled Arrival</th>
            <th>Actual Arrival</th>
            <th>Status</th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="user in users" :key="user.viberId">
            <td>{{ user.name }}</td>
            <td>{{ user.department }}</td>
            <td>{{ user.from }}</td>
            <td>{{ user.to }}</td>
            <td>{{ new Date(user.scheduled_arrival).toDateString().slice(4, -4) }}</td>
            <td>{{ new Date(user.scheduled_arrival).toLocaleTimeString().split(' ')[0].slice(0,-3)+' '+ new Date(user.scheduled_arrival).toLocaleTimeString().split(' ')[1]}}</td>
            <td>{{ user.actual_arrival === null || user.actual_arrival === -1 ? "Na" : new Date(user.actual_arrival).toLocaleTimeString().split(' ')[0].slice(0,-3)+' '+ new Date(user.actual_arrival).toLocaleTimeString().split(' ')[1] }}</td>
            <td :class="{ 'late-status': user.status === 'late', 'intransit' : user.status == 'intransit', 'warning' : user.status=='canceled' || user.status == 'late arrived' }">
              <span v-if="user.status === 'late'">
                <font-awesome-icon icon="fa-solid fa-hand" /> {{ user.status }}
              </span>
              <span v-else-if="user.status === 'intransit'">
                <font-awesome-icon icon="fa-solid fa-bicycle" /> {{ user.status }}
              </span>
              <span v-else-if="user.status === 'canceled' || user.status === 'late arrived'">
                <font-awesome-icon icon="fa-solid fa-circle-xmark" /> {{ user.status }}
              </span>
              <span v-else>
                <font-awesome-icon icon="fa-solid fa-hashtag" /> {{ user.status }}
              </span>
            </td>
            <!-- <td :class="{ 'late-status': user.status === 'late', 'intransit' : user.status == 'intransit', 'warning' : user.status=='canceled' || user.status == 'late arrived' }">{{ user.status }}</td> -->
          </tr>
        </tbody>
      </table>
      <p v-else>Error fetching user details: {{ errorMessage }}</p>
    </div>
  </div>
</template>

<script>
// import MyIcon from "@/MyIcon"
import axios from "axios"
export default {
  data() {
    return {
      users: [],
      errorMessage: '',
      late: 0,
      intransit: 0,
    };
  },
  methods: {
    formatScheduledArrival(value) {
      // Return the formatted value here
      // This is a placeholder and will need to be replaced
      return value;
    },
    formatActualArrival(value) {
      // Return the formatted value here
      // This is a placeholder and will need to be replaced
      return value;
    }
  },
  components:{
    // MyIcon
  },
  async mounted() {
    try {
      // const response = await axios.get(`https://promoted-tahr-game.ngrok-free.app/user_details`,{headers:{'ngrok-skip-browser-warning': 'true'}})
      const response = await axios.get(process.env.VUE_APP_BACKEND_URL+"user_details",{headers:{'ngrok-skip-browser-warning': 'true'}})
      this.users = response.data
      this.users.forEach(user => {
          if(user.status=="late")
            user.status = "late arrived"
          if(user.scheduled_arrival < Date.now() && user.status==""){
            user.status="late"
            this.late++
          }else if(user.status == ""){
            user.status="intransit"
            this.intransit++;
          }
        })
    }catch(e){
      console.error("Error occoured: ", e);
    }
  },
};
</script>


<style>
#app {
  font-family: 'Roboto', sans-serif;
  text-align: center;
  background: #F5F5F5;
  padding: 20px;
}
.metro-mark {
  width: 20px;
  height: 20px;
  background-color: #ff6c00; /* Metro color, change as needed */
  border-radius: 50%; /* Makes it a circle */
  display: flex;
  align-items: center;
  justify-content: center;
  font-weight: bold;
  color: #fff; /* Text color */
}
.table-container {
  margin-top: 40px;
  padding: 20px;
  border-radius: 10px;
  background: white;
  box-shadow: 0px 5px 15px rgba(0, 0, 0, 0.1);
}

table {
  border-collapse: collapse;
  width: 100%;
  background: white;
}

thead {
  background: linear-gradient(to right, #857FD2, #B1A8E8);
}

th,
td {
  border-bottom: 1px solid #ddd;
  padding: 15px;
  text-align: left;
}

th {
  color: white;
  background-clip: text;
}

.late-number{
    background-color: red;
    display: inline-block;
    margin: 2px;
    color: white;
    padding:5px;
    border-radius: 10px; /* This makes it round */
    width: auto; /* Adjust the width and height as needed */
    height: 18px;
    text-align: center; /* Center the text horizontally and vertically */
}
.intransit-number{
    background-color: green;
    display: inline-block;
    margin: 2px;
    color: white;
    padding:5px;
    border-radius: 10px; /* This makes it round */
    width: auto; /* Adjust the width and height as needed */
    height: 18px;
    text-align: center; /* Center the text horizontally and vertically */
}
.late-status {
  color: red;
  font-weight: bold;
}
.intransit{
  color: green;
  font-weight: bold;
}
.warning{
  color: #ff7711;
  font-weight: bold;
}
tbody tr:nth-child(odd) {
  background-color: #ffffff;
}
tbody tr:nth-child(even) {
  background-color: #f6f1ff;
}

.header {
  display: flex;
  align-items: center;
  justify-content: center;
  gap: 5px;
}
.block{
  display: flex; /* Use flexbox to control child elements */
  flex-direction: column; /* Stack child elements vertically */
  align-items: center; /* Center-align child elements horizontally */
  margin-top: 5px; /* Add some top margin for spacing */
}
.icon {
  width: 30px;
  height: 30px;
}
h1 {
  color: #7065CD;
}
</style>
